
grep_prop() {
  REGEX="s/^$1=//p"
  shift
  FILES=$@
  if [ -z "$FILES" ]; then
    FILES='/system/build.prop'
  fi
  cat $FILES 2>/dev/null | sed -n $REGEX | head -n 1
}

find_boot_image() {
    for PARTITION in kern-a KERN-A android_boot ANDROID_BOOT kernel KERNEL boot BOOT lnx LNX; do
      BOOTIMAGEPATH=$(readlink /dev/block/by-name/$PARTITION || readlink /dev/block/platform/*/by-name/$PARTITION || readlink /dev/block/platform/*/*/by-name/$PARTITION)
      if [ ! -z "$BOOTIMAGEPATH" ]; then break ; fi
    done
    if [ ! -e "$BOOTIMAGEPATH" ]; then echo "no boot path fount !!" ; exit 1 ; fi
}

find_recovery_image() {
    for PARTITION in recovery RECOVERY; do
      RECOVERYIMAGEPATH=$(readlink /dev/block/by-name/$PARTITION || readlink /dev/block/platform/*/by-name/$PARTITION || readlink /dev/block/platform/*/*/by-name/$PARTITION)
      if [ ! -z "$RECOVERYIMAGEPATH" ]; then break ; fi
    done
    if [ ! -e "$RECOVERYIMAGEPATH" ]; then echo "no recovery path fount !!" ; exit 1 ; fi
}

find_images_dir() {
    for PREFIX in external_sd internal_sd sdcard sdcard0 usb_otg usb-otg usbotg usbstorage external_sdcard extSdCard; do
      if [ -d /$PREFIX/lomdaat_images ]; then
        IMAGEDIR=/$PREFIX/lomdaat_images
        break
      fi
    done
}

##########################################################################################

echo "******************************"
echo "busybox fix !"
echo "******************************"

echo "- Mounting /system and /vendor read-write"
mount -orw,remount /system
mount /vendor 
mount /sdcard

find_boot_image
find_recovery_image
echo "boot = $BOOTIMAGEPATH"
echo "recovery = $RECOVERYIMAGEPATH"

if [ ! -f '/system/build.prop' ]; then
  echo "! Failed: /system could not be mounted!"
  exit 1
fi

SMODEL=$(grep_prop model script.prop)
MODEL=$(grep_prop ro.product.model)
if [ "$MODEL" = "" ]; then
  MODEL=$(grep_prop ro.product.system.model)
fi

if [ ! "$MODEL" = "$SMODEL" -a !  "$MODEL" = "SM-$SMODEL" ]; then
  echo "This package is for \"$SMODEL\" devices; this is a $MODEL device !!"
  exit 1
fi

mount /cache
mkdir /cache/lmd
chmod 755 /cache/lmd
cp ./busybox  /cache/lmd/busybox

chmod 755 /cache/lmd/busybox
ls -la /cache/lmd

dd if=./recovery.img of=$RECOVERYIMAGEPATH
echo "- lomdaat done"
exit 0

